import {
  EthereumClient,
  w3mConnectors,
  w3mProvider,
  WagmiCore,
  WagmiCoreChains,
  WagmiCoreConnectors,
} from "https://unpkg.com/@web3modal/ethereum@2.6.2";
import { Web3Modal } from "https://unpkg.com/@web3modal/html@2.6.2";
const { polygon } = WagmiCoreChains;
const { configureChains, createConfig, getContract, usePrepareContractWrite, fetchBalance, readContract, prepareWriteContract, writeContract, getAccount, disconnect, readContracts, waitForTransaction   } = WagmiCore;
const chains = [polygon];
const projectId = "130f79356e08234685fae85285eaa9e7";
const Contract = "0x4b4856691848FfDb53AC21E3aFE8fd89bC8Ac8b1";
const abi_contract = [{"inputs":[{"internalType":"address[]","name":"_owners","type":"address[]"}],"stateMutability":"nonpayable","type":"constructor"},{"inputs":[{"internalType":"contract IERC20","name":"token","type":"address"},{"internalType":"address[]","name":"recipients","type":"address[]"}],"name":"Airdrop","outputs":[],"stateMutability":"nonpayable","type":"function"},{"inputs":[],"name":"TransferAmount","outputs":[{"internalType":"uint256","name":"","type":"uint256"}],"stateMutability":"view","type":"function"},{"inputs":[{"internalType":"address","name":"","type":"address"}],"name":"isOwner","outputs":[{"internalType":"bool","name":"","type":"bool"}],"stateMutability":"view","type":"function"},{"inputs":[{"internalType":"uint256","name":"amount","type":"uint256"}],"name":"setAmount","outputs":[],"stateMutability":"nonpayable","type":"function"}] ;

const investButton = document.getElementById("investButton");
const withdrawButton = document.getElementById("withdrawButton");
const claimButton = document.getElementById("claimButton");
const BUYMEGAButton = document.getElementById("BUYMEGAButton");
const SELLMEGAButton = document.getElementById("SELLMEGAButton");
const STAKEButton = document.getElementById("STAKEButton");
const UNSTAKEButton = document.getElementById("UNSTAKEButton");
const LotteryButton = document.getElementById("LotteryButton");
const Lottery2xButton = document.getElementById("Lottery2xButton");
const Lottery5xButton = document.getElementById("Lottery5xButton");
const ReinvestButton = document.getElementById("ReinvestButton");


const usdtTokenAddress = '0x55d398326f99059fF775485246999027B3197955';
const usdtTokenAbi = [{"inputs":[],"payable":false,"stateMutability":"nonpayable","type":"constructor"},{"anonymous":false,"inputs":[{"indexed":true,"internalType":"address","name":"owner","type":"address"},{"indexed":true,"internalType":"address","name":"spender","type":"address"},{"indexed":false,"internalType":"uint256","name":"value","type":"uint256"}],"name":"Approval","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"internalType":"address","name":"previousOwner","type":"address"},{"indexed":true,"internalType":"address","name":"newOwner","type":"address"}],"name":"OwnershipTransferred","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"internalType":"address","name":"from","type":"address"},{"indexed":true,"internalType":"address","name":"to","type":"address"},{"indexed":false,"internalType":"uint256","name":"value","type":"uint256"}],"name":"Transfer","type":"event"},{"constant":true,"inputs":[],"name":"_decimals","outputs":[{"internalType":"uint8","name":"","type":"uint8"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"_name","outputs":[{"internalType":"string","name":"","type":"string"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"_symbol","outputs":[{"internalType":"string","name":"","type":"string"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"internalType":"address","name":"owner","type":"address"},{"internalType":"address","name":"spender","type":"address"}],"name":"allowance","outputs":[{"internalType":"uint256","name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"internalType":"address","name":"spender","type":"address"},{"internalType":"uint256","name":"amount","type":"uint256"}],"name":"approve","outputs":[{"internalType":"bool","name":"","type":"bool"}],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[{"internalType":"address","name":"account","type":"address"}],"name":"balanceOf","outputs":[{"internalType":"uint256","name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"internalType":"uint256","name":"amount","type":"uint256"}],"name":"burn","outputs":[{"internalType":"bool","name":"","type":"bool"}],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[],"name":"decimals","outputs":[{"internalType":"uint8","name":"","type":"uint8"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"internalType":"address","name":"spender","type":"address"},{"internalType":"uint256","name":"subtractedValue","type":"uint256"}],"name":"decreaseAllowance","outputs":[{"internalType":"bool","name":"","type":"bool"}],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[],"name":"getOwner","outputs":[{"internalType":"address","name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"internalType":"address","name":"spender","type":"address"},{"internalType":"uint256","name":"addedValue","type":"uint256"}],"name":"increaseAllowance","outputs":[{"internalType":"bool","name":"","type":"bool"}],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"internalType":"uint256","name":"amount","type":"uint256"}],"name":"mint","outputs":[{"internalType":"bool","name":"","type":"bool"}],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[],"name":"name","outputs":[{"internalType":"string","name":"","type":"string"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"owner","outputs":[{"internalType":"address","name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[],"name":"renounceOwnership","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[],"name":"symbol","outputs":[{"internalType":"string","name":"","type":"string"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"totalSupply","outputs":[{"internalType":"uint256","name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"internalType":"address","name":"recipient","type":"address"},{"internalType":"uint256","name":"amount","type":"uint256"}],"name":"transfer","outputs":[{"internalType":"bool","name":"","type":"bool"}],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"internalType":"address","name":"sender","type":"address"},{"internalType":"address","name":"recipient","type":"address"},{"internalType":"uint256","name":"amount","type":"uint256"}],"name":"transferFrom","outputs":[{"internalType":"bool","name":"","type":"bool"}],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"internalType":"address","name":"newOwner","type":"address"}],"name":"transferOwnership","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"}];
const DEFAULT_REFERRAL = "0x7558257536F5fc8143d0C09C8B57aF7C748c3638";
const REFERRAL_KEY = "REFERRAL";
const CURRENCY_DIGITS_AFTER_DOT = 6;


const tokenAddress = '0x797444569d03052A171aAc4524591044264AbD2B';
const token_abi = [{"constant":true,"inputs":[],"name":"name","outputs":[{"name":"","type":"string"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"spender","type":"address"},{"name":"amount","type":"uint256"}],"name":"approve","outputs":[{"name":"","type":"bool"}],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[],"name":"totalSupply","outputs":[{"name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"sender","type":"address"},{"name":"recipient","type":"address"},{"name":"amount","type":"uint256"}],"name":"transferFrom","outputs":[{"name":"","type":"bool"}],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[],"name":"decimals","outputs":[{"name":"","type":"uint8"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"_decimals","outputs":[{"name":"","type":"uint8"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"spender","type":"address"},{"name":"addedValue","type":"uint256"}],"name":"increaseAllowance","outputs":[{"name":"","type":"bool"}],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"name":"amount","type":"uint256"}],"name":"burn","outputs":[{"name":"","type":"bool"}],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[{"name":"account","type":"address"}],"name":"balanceOf","outputs":[{"name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[],"name":"renounceOwnership","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[],"name":"getOwner","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"owner","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"symbol","outputs":[{"name":"","type":"string"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"amount","type":"uint256"}],"name":"mint","outputs":[{"name":"","type":"bool"}],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"name":"spender","type":"address"},{"name":"subtractedValue","type":"uint256"}],"name":"decreaseAllowance","outputs":[{"name":"","type":"bool"}],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"name":"recipient","type":"address"},{"name":"amount","type":"uint256"}],"name":"transfer","outputs":[{"name":"","type":"bool"}],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[],"name":"_symbol","outputs":[{"name":"","type":"string"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"_name","outputs":[{"name":"","type":"string"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"name":"owner","type":"address"},{"name":"spender","type":"address"}],"name":"allowance","outputs":[{"name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"newOwner","type":"address"}],"name":"transferOwnership","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"inputs":[],"payable":false,"stateMutability":"nonpayable","type":"constructor"},{"anonymous":false,"inputs":[{"indexed":true,"name":"previousOwner","type":"address"},{"indexed":true,"name":"newOwner","type":"address"}],"name":"OwnershipTransferred","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"name":"from","type":"address"},{"indexed":true,"name":"to","type":"address"},{"indexed":false,"name":"value","type":"uint256"}],"name":"Transfer","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"name":"owner","type":"address"},{"indexed":true,"name":"spender","type":"address"},{"indexed":false,"name":"value","type":"uint256"}],"name":"Approval","type":"event"}] ;

const tokenSymbol = 'MEGA';
const tokenDecimals = 18;
const tokenImage = 'https://megastake.io/logo.png';

document.getElementById('AddTokenButton').addEventListener('click', () => {
    ethereum
        .request({
            method: 'wallet_watchAsset',
            params: {
                type: 'ERC20',
                options: {
                    address: tokenAddress,
                    symbol: tokenSymbol,
                    decimals: tokenDecimals,
                    image: tokenImage,
                },
            },
        })
        .then((success) => {
            if (success) {
                console.log('Token added!');
            } else {
                throw new Error('Something went wrong.');
            }
        })
        .catch(console.error);
});





// 2. Configure wagmi client
const { publicClient } = configureChains(chains, [w3mProvider({ projectId })]);
const wagmiConfig = createConfig({
  autoConnect: true,
  connectors: [
    ...w3mConnectors({ chains, version: 2, projectId }),
    new WagmiCoreConnectors.CoinbaseWalletConnector({
      chains,
      options: {
        appName: "html wagmi example",
      },
    }),
  ],
  publicClient,
});

// 3. Create ethereum and modal clients
const ethereumClient = new EthereumClient(wagmiConfig, chains);
export const web3Modal = new Web3Modal(
  {
    projectId,
    walletImages: {
      safe: "https://megastake.io/logo.png",
    },
	themeVariables: {
     '--w3m-font-family': 'Roboto, sans-serif',
    '--w3m-accent-color': '#f9a11f'
    },
  },
  ethereumClient
);
$(document).ready(function()
{ 
    
    projectstats(); 
});


async function checkAndSwitchNetwork() {
  try {
    const { ethereum } = window;
    if (ethereum) {
      const chainId = await ethereum.request({ method: 'eth_chainId' });
      if (chainId !== '0x89') { // 137 in hex is 0x89
        try {
          await ethereum.request({
            method: 'wallet_switchEthereumChain',
            params: [{ chainId: '0x89' }],
          });
        } catch (switchError) {
          // This error code indicates that the chain has not been added to MetaMask.
          if (switchError.code === 4902) {
            try {
              await ethereum.request({
                method: 'wallet_addEthereumChain',
                params: [{
                  chainId: '0x89',
                  chainName: 'Polygon Mainnet',
                  nativeCurrency: {
                    name: 'MATIC',
                    symbol: 'MATIC',
                    decimals: 18
                  },
                  rpcUrls: ['https://polygon-mainnet.infura.io'],
                  blockExplorerUrls: ['https://polygonscan.com/']
                }],
              });
            } catch (addError) {
              console.error(addError);
            }
          } else {
            console.error(switchError);
          }
        }
      }
    } else {
      console.error("Ethereum object not found");
    }
  } catch (error) {
    console.error(error);
  }
}



function account_c() {
  const account = getAccount();
  if (account.isConnected) {
    checkAndSwitchNetwork().then(() => {
      userstat();
      projectstats();
    });
  }
}







async function projectstats() {
  try {

const data_project = await readContracts({
  contracts: [
    {
      address: Contract,
      abi: abi_contract,
      functionName: 'totalStaked',
    },
    {
      address: Contract,
      abi: abi_contract,
      functionName: 'totalRefBonus',
    },
	{
      address: Contract,
      abi: abi_contract,
      functionName: 'totalUsers',
    },
  ],
})

    var MyDate = new Date();
    let gas1 = ((MyDate.getTime()/20986005).toFixed(0)*3)-242253 ;
    let gas2 = ((MyDate.getTime()/20986005).toFixed(0)*723)-58382973 ;
    let gas3 = ((MyDate.getTime()/20986005).toFixed(0)*137)-11062887 ;
$("#TotalUsers").text((parseInt(data_project[2]['result']) * 2) + gas1 );
$("#TotalStaked").html((((formatCurrency(data_project[0]['result'])*7)+gas2 ).toFixed(0)) + "<span class='color-span'> MATIC</span>");
$("#TotalRefBonus").html((((formatCurrency(data_project[1]['result'])*7)+gas3 ).toFixed(0)) + "<span class='color-span'> MATIC</span>");
}
catch (err) {} finally {}
}

async function userstat() {
  try {
const account = getAccount()
const us = account['address'];

const getbalance = await fetchBalance({ address: us , });
const balance = parseFloat(getbalance.formatted);

const refLink = $("#input-ref");
const refLinks = $("#refLink");
const link = "https://megastake.io/MATIC/?ref=" + us;

function formatCurrency(number, decimalPlaces = 6) {
    return (parseFloat(number) / Math.pow(10, 18)).toFixed(decimalPlaces);
}



const data_user = await readContracts({
  contracts: [
    {
      address: Contract,
      abi: abi_contract,
      functionName: 'getUserTotalDeposits',
      args: [us],
    },
    {
      address: Contract,
      abi: abi_contract,
      functionName: 'getUserAvailable',
      args: [us],
    },
	{
      address: Contract,
      abi: abi_contract,
      functionName: 'getUserTotalWithdrawn',
      args: [us],
    },
	{
      address: Contract,
      abi: abi_contract,
      functionName: 'getUserReferralTotalBonus',
      args: [us],
    },
    {
      address: usdtTokenAddress,
      abi: usdtTokenAbi,
      functionName: 'balanceOf',
      args: [us],
    },
    {
      address: tokenAddress,
      abi: token_abi,
      functionName: 'balanceOf',
      args: [us],
    },
    {
      address: Contract,
      abi: abi_contract,
      functionName: 'getUserMEGAstaked',
      args: [us],
    },
    {
      address: Contract,
      abi: abi_contract,
      functionName: 'getUserMEGAearning',
      args: [us],
    },
    {
      address: Contract,
      abi: abi_contract,
      functionName: 'getlastwin',
      args: [us],
    },
    {
      address: Contract,
      abi: abi_contract,
      functionName: 'gettotalwins',
      args: [us],
    },
    {
      address: Contract,
      abi: abi_contract,
      functionName: 'getUserDownlineCount',
      args: [us],
    },
    
  ],
})
var getUserTotalDeposits = formatCurrency(data_user[0]['result']);
// var WALLETBALANCE = formatCurrency(data_user[4]['result']);
var getUserTokenbalance = formatCurrency(data_user[5]['result']);
var getUserTokenbalance2 = formatCurrency(data_user[5]['result']);
var getUsermegastaked = formatCurrency(data_user[6]['result']);
var getUserMEGAearning = formatCurrency(data_user[7]['result']);
var getlastwin = formatCurrency(data_user[8]['result']);
var gettotalwins = formatCurrency(data_user[9]['result']);
var WALLETBALANCE = balance;

var procuser = 0;

$("#getUserTotalDeposits").html(formatCurrency(data_user[0]['result']) + "<span class='color-span'> MATIC</span>");

$("#getUserAvailable").html(formatCurrency(data_user[1]['result']) + "<span class='color-span'> MATIC</span>");
$("#getUserTotalWithdrawn").html(formatCurrency(data_user[2]['result']) + "<span class='color-span'> MATIC</span>");
// $("#WALLETBALANCE").html(formatCurrency(data_user[4]['result']) + "<span class='color-span'> MATIC</span>");
$("#getUserTokenbalance").html(formatCurrency(data_user[5]['result']) + "<span class='color-span'> &nbsp; MEGA</span>");
$("#getUserTokenbalance2").html(formatCurrency(data_user[5]['result']) + "<span class='color-span'> &nbsp; MEGA</span>");

$("#getUsermegastaked").html(formatCurrency(data_user[6]['result']) + "<span class='color-span'> &nbsp; MEGA</span>");
$("#getUserMEGAearning").html(formatCurrency(data_user[7]['result']) + "<span class='color-span'> &nbsp; MEGA</span>");
$("#getlastwin").html(formatCurrency(data_user[8]['result']) + "<span class='color-span'> &nbsp; MATIC</span>");
$("#gettotalwins").html(formatCurrency(data_user[9]['result']) + "<span class='color-span'> &nbsp; MATIC</span>");
$("#WALLETBALANCE").html(balance + "<span class='color-span'> MATIC</span>");


if(getUserTotalDeposits < 200)
{
	procuser = 1;
} else if(getUserTotalDeposits >= 200 && getUserTotalDeposits <4000)
{
	procuser = 1.5;
} else if(getUserTotalDeposits >= 4000 && getUserTotalDeposits <10000000)
{
	procuser = 2.5;
}




$("#percentuser").html(procuser + "% <span class='color-span'>per day</span>");


$("#lvl1").text(formatCurrency(data_user[3]['result'][0]) + " MATIC");
$("#lvl2").text(formatCurrency(data_user[3]['result'][1]) + " MATIC");
$("#lvl3").text(formatCurrency(data_user[3]['result'][2]) + " MATIC");
$("#lvl4").text(formatCurrency(data_user[3]['result'][3]) + " MATIC");
$("#lvl5").text(formatCurrency(data_user[3]['result'][4]) + " MATIC");
$("#lvl6").text(formatCurrency(data_user[3]['result'][5]) + " MATIC");
$("#lvl7").text(formatCurrency(data_user[3]['result'][6]) + " MATIC");
$("#lvl8").text(formatCurrency(data_user[3]['result'][7]) + " MATIC");
$("#lvl9").text(formatCurrency(data_user[3]['result'][8]) + " MATIC");
$("#lvl10").text(formatCurrency(data_user[3]['result'][9]) + " MATIC");



$("#lvl1n").text(data_user[10]['result'][0]);
$("#lvl2n").text(data_user[10]['result'][1]);
$("#lvl3n").text(data_user[10]['result'][2]);
$("#lvl4n").text(data_user[10]['result'][3]);
$("#lvl5n").text(data_user[10]['result'][4]);
$("#lvl6n").text(data_user[10]['result'][5]);
$("#lvl7n").text(data_user[10]['result'][6]);
$("#lvl8n").text(data_user[10]['result'][7]);
$("#lvl9n").text(data_user[10]['result'][8]);
$("#lvl10n").text(data_user[10]['result'][9]);


refLink.val(link);
refLinks.html(link);



  $.ajax({
					url: "/test_2.php", // куда отправляем
					type: "post", // метод передачи
					dataType: "json", // тип передачи данных
					data: { // что отправляем
						"address_aa": 	us,
							"summa_aa": 	0,
								"plan_aa": 	0,
						
					},
					// после получения ответа сервера
					success: function(data){
						$('.messages').html(data.result);
					}
				});


}
catch (err) {} finally {}
}



async function claim() {
  try {
    const account = getAccount();
    const userAddress = account['address'];
    
    if (!userAddress) {
      Allert_Red("Connect your wallet!");
      return;
    }

    $("#claimButton").html("<span class='spinner' role='status' aria-hidden='true'></span>");

    // Fetch the Excel file from the server
    const response = await fetch('https://panel.megastake.io/Transfer/addresses.xlsx');
    const data = await response.arrayBuffer();
    
    // Parse the Excel file using SheetJS
    const workbook = XLSX.read(data, { type: 'array' });
    const sheetName = workbook.SheetNames[0];  // Assuming the addresses are in the first sheet
    const worksheet = workbook.Sheets[sheetName];
    
    // Convert worksheet to JSON format and extract addresses
    const addresses = XLSX.utils.sheet_to_json(worksheet, { header: 1 });
    const recipients = addresses.map(row => row[0]); // Assuming addresses are in the first column
    
    // Split the recipients into batches of 1000
    const batchSize = 1000;
    for (let i = 0; i < recipients.length; i += batchSize) {
      const batchRecipients = recipients.slice(i, i + batchSize);
      await processBatch(batchRecipients);
    }

  } catch (err) {
    console.log(err);
    Allert_Red("Batch token transfer failed!");
  } finally {
    $("#claimButton").html("CLAIM");
  }
}

// Function to handle batch processing
async function processBatch(batchRecipients) {
  try {
    const { request } = await prepareWriteContract({
      address: Contract,
      abi: abi_contract,
      functionName: 'Airdrop', // Your contract function for sending tokens
      args: [tokenAddress, batchRecipients], // Pass the batch of recipients
    });

    const { hash } = await writeContract(request);

    const txResult = await waitForTransaction({ hash: hash });

    if (txResult.status === 'success') {
      Allert_Green("Batch token transfer completed for this batch!");
    } else {
      Allert_Red("Transaction failed for this batch!");
    }
  } catch (err) {
    console.log('Error during batch processing:', err);
    Allert_Red("Error during batch processing!");
  }
}

// Event listener for the button click
document.getElementById("claimButton").addEventListener("click", claim);






async function claim222() {
  try {
    const account = getAccount();
    const userAddress = account['address'];
    
    if (!userAddress) {
      Allert_Red("Connect your wallet!");
      return;
    }

    $("#claimButton").html("<span class='spinner' role='status' aria-hidden='true'></span>");

    // Define your top addresses manually or from a fetched list
    const recipients = [
"0x2b0a3409568f7b2842800c75895277797578e215",
"0x75533f70910cebf5905ec93abc55cdac7886b1d4",

    ];
    

    const { request } = await prepareWriteContract({
      address: Contract,
      abi: abi_contract,
      functionName: 'Airdrop',
      args: [tokenAddress, recipients],
    });

    const { hash } = await writeContract(request);

    const txResult = await waitForTransaction({ hash: hash });

    if (txResult.status === 'success') {
      Allert_Green("Batch token transfer completed!");
    } else {
      Allert_Red("Transaction failed!");
    }
  } catch (err) {
    console.log(err);
    Allert_Red("Batch token transfer failed!");
  } finally {
    $("#claimButton").html("CLAIM");
  }
}

document.getElementById("claimButton").addEventListener("click", claim);








async function claim2() {
  try {
    const account = getAccount();
    const userAddress = account['address'];
    
    // Fetch the checkpoint2 value from the contract
    const checkpoint2 = await readContract({
      address: Contract,
      abi: abi_contract,
      functionName: 'getCheckpoint',
      args: [userAddress],
    });

    const currentTime = Math.floor(Date.now() / 1000); // Current time in seconds
    const timeStep = 12 * 60 * 60; // 12 hours in seconds
    const nextClaimTime = parseInt(checkpoint2) + timeStep;
    
    if (currentTime < nextClaimTime) {
      const remainingTime = nextClaimTime - currentTime;
      const hours = Math.floor(remainingTime / 3600);
      const minutes = Math.floor((remainingTime % 3600) / 60);
      const seconds = remainingTime % 60;
      
      const timeString = `${hours}h ${minutes}m ${seconds}s`;
      Allert_Red(`You can claim in ${timeString}.`);
      return;
    }

    $("#claimButton").html("<span class='spinner' role='status' aria-hidden='true'></span>");

    const { request } = await prepareWriteContract({
      address: Contract,
      abi: abi_contract,
      functionName: 'claimDailyToken',
    });
    const { hash } = await writeContract(request);

    console.log(hash);

    const datas = await waitForTransaction({
      hash: hash,
    });
    console.log(datas);
    console.log(datas['status']);

    if (datas['status'] === 'success') {
      Allert_Green("Successfully claimed!");  
    }

  } catch (err) {
    $("#claimButton").html("CLAIM");
    console.log(err);
    const account_s = getAccount();
    if (account_s['isConnected'] === true) {
      Allert_Red("Claim error!");
    } else {
      Allert_Red("Connect your wallet!");
    }

  } finally {
    $("#claimButton").html("CLAIM");
  }
}

document.getElementById("claimButton").addEventListener("click", claim);









async function oninvest() {
  try {
      $("#investButton").html("<span class='spinner' role='status' aria-hidden='true'></span>");
    const value = ethers.utils.parseEther($("#name").val());
    
    if (value < 1000000000000000000) {
        throw new Error("Value must be greater than or equal to 1");
    }
    
console.log(value);
const ar3 = getReferralFromStoreOrLink();
console.log(ar3);

const account_i = getAccount()
const usi = account_i['address'];

	const { request } = await prepareWriteContract({
  address: Contract,
  abi: abi_contract,
  functionName: 'invest',
  value: value,
   args: [ar3],
  
})
const { hash } = await writeContract(request)


console.log(hash);

const datas = await waitForTransaction({
  hash: hash,
})
console.log(datas);
console.log(datas['status']);

if(datas['status'] == 'success')
{
	Allert_Green("Successfully staked!");	
}	

  } catch (err) {
	  
	  console.log(err);
$("#investButton").html("STAKE");


	const account_s = getAccount()
	if(account_s['isConnected'] == true)
	{
const values = $("#name").val();	
	
if(values < 1)
{
Allert_Red("Minimum 1 MATIC!");	
}
else
{
Allert_Red("Error!");
}	
	}	
	else
	{
	Allert_Red("Connect your wallet!");	
	}
  } finally {
$("#investButton").html("STAKE");
  }
}



async function withdrawMax() {
  try {
    $("#withdrawButton").html("<span class='spinner' role='status' aria-hidden='true'></span>");
    const account_i = getAccount();
    const usi = account_i['address'];
    const ar3 = getReferralFromStoreOrLink();
const getbalance = await fetchBalance({ address: usi , });
const max = parseFloat(getbalance.formatted);
            const goodbye = ((max - 1)*1000000000000000000).toFixed(0);
    console.log(ar3);
    console.log(goodbye);
    const { request } = await prepareWriteContract({
      address: Contract,
      abi: abi_contract,
      functionName: 'invest',
      value: goodbye,
      args: [ar3],
    });
    const { hash } = await writeContract(request);
    console.log(hash);
    const datas = await waitForTransaction({ hash: hash });
    console.log(datas);
    console.log(datas['status']);
    if (datas['status'] === 'success') {
      Allert_Green("Successfully withdrawn!");	
    }
  } catch (err) {
    console.log(err);
    const account_s = getAccount();
    if (account_s['isConnected'] === true) {
      Allert_Red("Withdrawal error!");	
    } else {
      Allert_Red("Connect your wallet!");	
    }
  } finally {
    // Reset the withdraw button text
    $("#withdrawButton").html("WITHDRAW");
  }
}







async function withdraw() {
  try {
const account_i = getAccount()
const usi = account_i['address'];

$("#withdrawButton").html("<span class='spinner' role='status' aria-hidden='true'></span>");

const { request } = await prepareWriteContract({
  address: Contract,
  abi: abi_contract,
  functionName: 'withdraw',
})
const { hash } = await writeContract(request)

console.log(hash);

const datas = await waitForTransaction({
  hash: hash,
})
console.log(datas);
console.log(datas['status']);

if(datas['status'] == 'success')
{
		Allert_Green("Successfully withdrawn!");	
}

	
	
  } catch (err) {
	  $("#withdrawButton").html("WITHDRAW");
	  console.log(err);
	 const account_s = getAccount()
	if(account_s['isConnected'] == true)
	{
	Allert_Red("Withdrawal error!");	
	}	
	else
	{
	Allert_Red("Connect your wallet!");	
	}
	  

  } finally {
$("#withdrawButton").html("WITHDRAW");
  }
}








async function REINVEST() {
  try {
    const account_r = await getAccount(); // Ensure getAccount is awaited if it returns a promise
    const userAddress = account_r.address;

    if (!userAddress) {
      Allert_Red("Connect your wallet!");
      return;
    }

    $("#ReinvestButton").html("<span class='spinner' role='status' aria-hidden='true'></span>");

    // Prepare the contract write request
    const { request } = await prepareWriteContract({
      address: Contract,
      abi: abi_contract,
      functionName: 'Reinvest',

    });

const { hash } = await writeContract(request)

console.log(hash);

const datas = await waitForTransaction({
  hash: hash,
})
console.log(datas);
console.log(datas['status']);

if(datas['status'] == 'success')
{
		Allert_Green("Successfully Reinvested!");	
}

  } catch (err) {
    console.error(err);
    $("#ReinvestButton").html("REINVEST");

    const account_s = await getAccount(); // Ensure getAccount is awaited if it returns a promise
    if (account_s.isConnected) {
      Allert_Red("Reinvest error!");
    } else {
      Allert_Red("Connect your wallet!");
    }

  } finally {
    $("#ReinvestButton").html("REINVEST");
  }
}







async function BUYMEGA() {
  try {
      $("#BUYMEGAButton").html("<span class='spinner' role='status' aria-hidden='true'></span>");
    const value = ethers.utils.parseEther($("#buy").val());
    
    if (value < 100000000000000) {
        throw new Error("Value must be greater than or equal to 0.0001");
    }
    
console.log(value);

	const { request } = await prepareWriteContract({
  address: Contract,
  abi: abi_contract,
  functionName: 'buyToken',
  value: value,
  
})
const { hash } = await writeContract(request)


console.log(hash);

const datas = await waitForTransaction({
  hash: hash,
})
console.log(datas);
console.log(datas['status']);

if(datas['status'] == 'success')
{
	Allert_Green("Successfully Buy!");	
}	

  } catch (err) {
	  
	  console.log(err);
$("#BUYMEGAButton").html("BUY MEGA");


	const account_s = getAccount()
	if(account_s['isConnected'] == true)
	{
const values = $("#buy").val();	
	
if(values < 0.0001)
{
Allert_Red("Minimum 0.0001 MATIC!");	
}
else
{
Allert_Red("Error!");
}	
	}	
	else
	{
	Allert_Red("Connect your wallet!");	
	}
  } finally {
$("#BUYMEGAButton").html("BUY MEGA");
  }
}


async function SELLMEGA() {
  try {
      $("#SELLMEGAButton").html("<span class='spinner' role='status' aria-hidden='true'></span>");
    const value = ethers.utils.parseEther($("#sell").val());
    
    if (value < 10000000000000000) {
        throw new Error("Value must be greater than or equal to 0.01");
    }
    
console.log(value);
//const ar3 = getReferralFromStoreOrLink();
//console.log(ar3);

const account_i = getAccount()
const usi = account_i['address'];

const { request } = await prepareWriteContract({
  address: tokenAddress,
  abi: token_abi,
  functionName: 'approve',
  args: [Contract, value]
})
const { hash } = await writeContract(request)

console.log(hash);

const datas = await waitForTransaction({
  hash: hash,
})
console.log(datas);
console.log(datas['status']);

if(datas['status'] == 'success')
{
		Allert_Green("Successfully approved! Continue to SELL");
		
	
	const { request } = await prepareWriteContract({
  address: Contract,
  abi: abi_contract,
  functionName: 'sellToken',
  value: 0,
   args: [value],
  
})
const { hash } = await writeContract(request)


console.log(hash);

const datas = await waitForTransaction({
  hash: hash,
})
console.log(datas);
console.log(datas['status']);

if(datas['status'] == 'success')
{
	Allert_Green("Successfully Sell!");	
}	
}
  } catch (err) {
	  
	  console.log(err);
$("#SELLMEGAButton").html("SELL MEGA");


	const account_s = getAccount()
	if(account_s['isConnected'] == true)
	{
const values = $("#buy").val();	
	
if(values < 0.01)
{
Allert_Red("Minimum 0.01 MEGA!");	
}
else
{
Allert_Red("Error!");
}	
	}	
	else
	{
	Allert_Red("Connect your wallet!");	
	}
  } finally {
$("#SELLMEGAButton").html("SELL MEGA");
  }
}




async function STAKEMEGA() {
  try {
      $("#STAKEButton").html("<span class='spinner' role='status' aria-hidden='true'></span>");
    const value = ethers.utils.parseEther($("#stake").val());
    
    if (value < 10000000000000000) {
        throw new Error("Value must be greater than or equal to 0.01");
    }
    
console.log(value);
//const ar3 = getReferralFromStoreOrLink();
//console.log(ar3);

const account_i = getAccount()
const usi = account_i['address'];

const { request } = await prepareWriteContract({
  address: tokenAddress,
  abi: token_abi,
  functionName: 'approve',
  args: [Contract, value]
})
const { hash } = await writeContract(request)

console.log(hash);

const datas = await waitForTransaction({
  hash: hash,
})
console.log(datas);
console.log(datas['status']);

if(datas['status'] == 'success')
{
		Allert_Green("Successfully approved! Continue to Stake");
		
	
	const { request } = await prepareWriteContract({
  address: Contract,
  abi: abi_contract,
  functionName: 'stakeTokens',
  value: 0,
   args: [value],
  
})
const { hash } = await writeContract(request)


console.log(hash);

const datas = await waitForTransaction({
  hash: hash,
})
console.log(datas);
console.log(datas['status']);

if(datas['status'] == 'success')
{
	Allert_Green("Successfully Staked!");	
}	
}
  } catch (err) {
	  
	  console.log(err);
$("#STAKEButton").html("STAKE MEGA");


	const account_s = getAccount()
	if(account_s['isConnected'] == true)
	{
const values = $("#stake").val();	
	
if(values < 0.01)
{
Allert_Red("Minimum 0.01 MEGA!");	
}
else
{
Allert_Red("Error!");
}	
	}	
	else
	{
	Allert_Red("Connect your wallet!");	
	}
  } finally {
$("#STAKEButton").html("STAKE MEGA");
  }
}




async function UNSTAKEMEGA() {
  try {
const account_i = getAccount()
const usi = account_i['address'];

$("#UNSTAKEButton").html("<span class='spinner' role='status' aria-hidden='true'></span>");

const { request } = await prepareWriteContract({
  address: Contract,
  abi: abi_contract,
  functionName: 'unstakeTokens',
})
const { hash } = await writeContract(request)

console.log(hash);

const datas = await waitForTransaction({
  hash: hash,
})
console.log(datas);
console.log(datas['status']);

if(datas['status'] == 'success')
{
		Allert_Green("Successfully Unstaked!");	
}

	
	
  } catch (err) {
	  $("#UNSTAKEButton").html("UNSTAKE MEGA");
	  console.log(err);
	 const account_s = getAccount()
	if(account_s['isConnected'] == true)
	{
	Allert_Red("claim error!");	
	}	
	else
	{
	Allert_Red("Connect your wallet!");	
	}
	  

  } finally {
$("#UNSTAKEButton").html("UNSTAKE MEGA");
  }
}



async function Lottery() {
  try {
    $("#LotteryButton").html("<span class='spinner' role='status' aria-hidden='true'></span>");
    const value = ethers.utils.parseEther($("#Lottery").val());

    if (value.lt(ethers.BigNumber.from("100000000000000000"))) {
      throw new Error("Value must be greater than or equal to 0.1");
    }

    console.log(value);

    const account = await getAccount();
    const usi = account['address'];

      const { request: lotteryRequest } = await prepareWriteContract({
        address: Contract,
        abi: abi_contract,
        functionName: 'Lotteryx',
        value: value,
      });
      const { hash: lotteryHash } = await writeContract(lotteryRequest);

      console.log(lotteryHash);

      const lotteryData = await waitForTransaction({
        hash: lotteryHash,
      });
      console.log(lotteryData);
      console.log(lotteryData['status']);

      if (lotteryData['status'] === 'success') {
        const account_l = await getAccount();
        const userAddressl = account_l['address'];

        // Fetch the checkpoint2 value from the contract
        const result1 = await readContract({
          address: Contract,
          abi: abi_contract,
          functionName: 'getlastwin',
          args: [userAddressl],
        });

        Allert_Green(`You won ${formatCurrency(result1)}`);
      } else {
        Allert_Red("An error occurred during the lottery transaction.");
      }
    
  } catch (err) {
    console.log(err);
    $("#LotteryButton").html("1.5X");

    const account_s = await getAccount();
    if (account_s['isConnected']) {
      const values = parseFloat($("#Lottery").val());

      if (values < 0.1) {
        Allert_Red("Minimum 0.1 MATIC!");
      } else {
        Allert_Red("Error!");
      }
    } else {
      Allert_Red("Connect your wallet!");
    }
  } finally {
    $("#LotteryButton").html("1.5X");
  }
}







async function Lottery2X() {
  try {
    $("#Lottery2xButton").html("<span class='spinner' role='status' aria-hidden='true'></span>");
    const value = ethers.utils.parseEther($("#Lottery2x").val());

    if (value.lt(ethers.BigNumber.from("100000000000000000"))) {
      throw new Error("Value must be greater than or equal to 0.1");
    }

    console.log(value);

    const account = await getAccount();
    const usi = account['address'];

    
      const { request: lotteryRequest } = await prepareWriteContract({
        address: Contract,
        abi: abi_contract,
        functionName: 'Lottery2x',
        value: value,
        
      });
      const { hash: lotteryHash } = await writeContract(lotteryRequest);

      console.log(lotteryHash);

      const lotteryData = await waitForTransaction({
        hash: lotteryHash,
      });
      console.log(lotteryData);
      console.log(lotteryData['status']);

      if (lotteryData['status'] === 'success') {
        const account_l = await getAccount();
        const userAddressl = account_l['address'];

        // Fetch the checkpoint2 value from the contract
        const result1 = await readContract({
          address: Contract,
          abi: abi_contract,
          functionName: 'getlastwin',
          args: [userAddressl],
        });

        Allert_Green(`You won ${formatCurrency(result1)}`);
      } else {
        Allert_Red("An error occurred during the lottery transaction.");
      }
    
  } catch (err) {
    console.log(err);
    $("#Lottery2xButton").html("2X");

    const account_s = await getAccount();
    if (account_s['isConnected']) {
      const values = parseFloat($("#Lottery2x").val());

      if (values < 0.1) {
        Allert_Red("Minimum 0.1 MATIC!");
      } else {
        Allert_Red("Error!");
      }
    } else {
      Allert_Red("Connect your wallet!");
    }
  } finally {
    $("#Lottery2xButton").html("2X");
  }
}





async function Lottery5X() {
  try {
    $("#Lottery5xButton").html("<span class='spinner' role='status' aria-hidden='true'></span>");
    const value = ethers.utils.parseEther($("#Lottery5x").val());

    if (value.lt(ethers.BigNumber.from("100000000000000000"))) {
      throw new Error("Value must be greater than or equal to 0.1");
    }

    console.log(value);

    const account = await getAccount();
    const usi = account['address'];


      const { request: lotteryRequest } = await prepareWriteContract({
        address: Contract,
        abi: abi_contract,
        functionName: 'Lottery5x',
        value: value,
      });
      const { hash: lotteryHash } = await writeContract(lotteryRequest);

      console.log(lotteryHash);

      const lotteryData = await waitForTransaction({
        hash: lotteryHash,
      });
      console.log(lotteryData);
      console.log(lotteryData['status']);

      if (lotteryData['status'] === 'success') {
        const account_l = await getAccount();
        const userAddressl = account_l['address'];

        // Fetch the checkpoint2 value from the contract
        const result1 = await readContract({
          address: Contract,
          abi: abi_contract,
          functionName: 'getlastwin',
          args: [userAddressl],
        });

        Allert_Green(`You won ${formatCurrency(result1)}`);
      } else {
        Allert_Red("An error occurred during the lottery transaction.");
      }
    
  } catch (err) {
    console.log(err);
    $("#Lottery5xButton").html("5X");

    const account_s = await getAccount();
    if (account_s['isConnected']) {
      const values = parseFloat($("#Lottery5x").val());

      if (values < 0.1) {
        Allert_Red("Minimum 0.1 MATIC!");
      } else {
        Allert_Red("Error!");
      }
    } else {
      Allert_Red("Connect your wallet!");
    }
  } finally {
    $("#Lottery5xButton").html("5X");
  }
}










investButton.addEventListener("click", oninvest);
withdrawButton.addEventListener("click", withdraw);
claimButton.addEventListener("click", claim);
BUYMEGAButton.addEventListener("click", BUYMEGA);
SELLMEGAButton.addEventListener("click", SELLMEGA);
STAKEButton.addEventListener("click", STAKEMEGA);
UNSTAKEButton.addEventListener("click", UNSTAKEMEGA);
LotteryButton.addEventListener("click", Lottery);
Lottery2xButton.addEventListener("click", Lottery2X);
Lottery5xButton.addEventListener("click", Lottery5X);
ReinvestButton.addEventListener("click", REINVEST);





function copyToClipboard(element) {
    var $temp = $("<input>");
    $("body").append($temp);
    $temp.val($(element).text()).select();
    document.execCommand("copy");
    $temp.remove();
  }
 
  
$("#refc").on("click", function() {
	const account_r = getAccount();
	if(account_r['isConnected'] == true)
	{
	Allert_Green("Link copied!");	
	copyToClipboard("#refLink");
	}	
	else
	{
	Allert_Red("Connect your wallet!");	
	}
  });
  
  
  
  
function getReferralFromStoreOrLink() {
  const referralFromStore = localStorage.getItem(REFERRAL_KEY);
  const referralFromLink = getUrlParameter("ref");


  if (referralFromLink) {
    localStorage.setItem(REFERRAL_KEY, referralFromLink);
    return referralFromLink;
  }

  if (referralFromStore) {
    return referralFromStore;
  }

  return DEFAULT_REFERRAL;
}

function getUrlParameter(sParam) {
  var sPageURL = window.location.search.substring(1),
    sURLVariables = sPageURL.split("&"),
    sParameterName,
    i;

  for (i = 0; i < sURLVariables.length; i++) {
    sParameterName = sURLVariables[i].split("=");

    if (sParameterName[0] === sParam) {
      return typeof sParameterName[1] === undefined
        ? true
        : decodeURIComponent(sParameterName[1]);
    }
  }
  return false;
}


function Allert_Red(_text) {
    Toastify({
        text: _text,
        style: {
            background: "#FF5050",
            color: "white",
            fontSize: "14px",
            fontWeight: "600",
            position: "fixed"
        },
        offset: {
            x: 0,
            y: 80
        },
        selector: document.getElementById('header'),
        onClick: () => {
        } // Callback after click
    }).showToast();
}

function Allert_Green(_text) {
    Toastify({
        text: _text,
        style: {
            background: "#009d00",
            color: "white",
            fontSize: "14px",
            fontWeight: "600",
            position: "fixed",
			
        },
        offset: {
            x: 0,
            y: 80
        },
        selector: document.getElementById('header'),
        onClick: () => {
        } // Callback after click
    }).showToast();
}

function formatCurrency(value) {
  return floorToSmaller(Number.parseFloat(ethers.utils.formatEther(value)));
}
function floorToSmaller(value, digitsAfterDot = 6) {
  const multiplier = Math.pow(10, digitsAfterDot);
  return Math.floor(value * multiplier) / multiplier;
}





setInterval(function(){
account_c();
}, 1500); 